unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ShellAPI, Menus, Inifiles, ImgList, MMSystem;

const
     WM_TRAYICON = WM_USER + 1;
     TOTALBOMBNUMBER = 40;
type
    BombStatus = (bsNormal, bsMaskAsBomb, bsNumber0, bsNumber1, bsNumber2, bsNumber3, bsNumber4, bsNumber5, bsNumber6, bsNumber7, bsNumber8, bsExploded, bsWrong, bsShow);
    HighScoreRec = record
               Name : string[8];
               Date : string[10];
               Time : string[8];
    end;


  TMainForm = class(TForm)
    ImageLedLNum: TImageList;
    MinImage: TImage;
    CloseImage: TImage;
    Timer: TTimer;
    PopupMenu: TPopupMenu;
    pmShow: TMenuItem;
    pmClose: TMenuItem;
    pmAbout: TMenuItem;
    Image: TImage;
    StartBtnImage: TImage;
    pmShowHighScore: TMenuItem;
    MenuImage: TImage;
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CloseImageClick(Sender: TObject);
    procedure CloseImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CloseImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MinImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MinImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerTimer(Sender: TObject);
    procedure MinImageClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pmCloseClick(Sender: TObject);
    procedure pmShowClick(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartBtnImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartBtnImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartBtnImageClick(Sender: TObject);
    procedure pmShowHighScoreClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pmAboutClick(Sender: TObject);
    procedure MenuImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuImageClick(Sender: TObject);

  private
    { Private declarations }
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST;
  public
    { Public declarations }
    BackGroundBitmap : TBitmap;
    BombStatusBitmap : array [bsNormal..bsShow] of TBitmap;
    BombStatusBitmapName : array [bsNormal..bsShow] of integer;

//    BeginDrag : Boolean;
//    bx : integer;
//    by : integer;

    BombNumber, Hour, Minute, Second : integer;
    BombArray : array [0..255] of -1..1;
    BombStatusArray : array [ 0..255] of BombStatus;
    ClickNumber : integer;
    bGameOver : Boolean;
    bGameRunning : Boolean;
    bLeftBtnDown : Boolean;
    bRightBtnDown : Boolean;
    INIFile : TIniFile;
    HighScore : array [0..9] of HighScoreRec;
    NewRecordPos : integer;
    procedure IconCallBackMessage( var Msg : TMessage ); message WM_TRAYICON;
    procedure DrawTimeAndBombNumber;
    procedure DoTrayIconRightClick;
    procedure InitBomb;
    procedure ShowBomb;
    procedure DoTurnOver;
    procedure TurnItOver(n : integer);
    procedure CheckAll;
    procedure CheckIt(n : integer);
    procedure GameOver;
    function YouWin:Boolean;
    function MakeNewRecord:Boolean;
    procedure ShowHighScore;
    procedure UpdateHighScore;
    procedure ShowNormal;

  end;

var
  MainForm: TMainForm;
  MyNotifyStruct: TNotifyIconData;
implementation

uses Score, Ask, About;

{$R *.DFM}
procedure TMainForm.FormPaint(Sender: TObject);
begin
     Canvas.Draw(0,0,BackGroundBitmap);
     DrawTimeAndBombNumber;
     ShowBomb;
     ShowWindow (Application.Handle, SW_HIDE);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   loop : BombStatus;
   i : integer;
begin
     for i := 0 to 9 do
     begin
          HighScore[i].Name := '--------';
          HighScore[i].Date := '----/--/--';
          HighScore[i].Time := '--:--';
     end;

     INIFile := TIniFile.Create('.\Saolei.ini');

     for i := 0 to 9 do
     begin
          HighScore[i].Name := INIFile.ReadString(IntToStr(i), 'Name', '--------');
          HighScore[i].Date := INIFile.ReadString(IntToStr(i), 'Date', '----/--/--');
          HighScore[i].Time := INIFile.ReadString(IntToStr(i), 'Time', '--:--');
     end;

     bGameOver := FALSE;
     bGameRunning := FALSE;
     Timer.Enabled := FALSE;
     BombStatusBitmapName[bsNormal] := 113;
     BombStatusBitmapName[bsMaskAsBomb] := 112;
     BombStatusBitmapName[bsNumber0] := 102;
     BombStatusBitmapName[bsNumber1] := 103;
     BombStatusBitmapName[bsNumber2] := 104;
     BombStatusBitmapName[bsNumber3] := 105;
     BombStatusBitmapName[bsNumber4] := 106;
     BombStatusBitmapName[bsNumber5] := 107;
     BombStatusBitmapName[bsNumber6] := 108;
     BombStatusBitmapName[bsNumber7] := 109;
     BombStatusBitmapName[bsNumber8] := 110;

     BombStatusBitmapName[bsExploded] := 111;
     BombStatusBitmapName[bsWrong] := 115;
     BombStatusBitmapName[bsShow] := 114;

     SetWindowLong(Handle,GWL_STYLE, GetWindowLong(Handle,GWL_STYLE) and not WS_CAPTION);
     BackGroundBitmap := TBitmap.Create;
//     BackGroundBitmap.LoadFromFile('background.bmp');
     BackGroundBitmap.LoadFromResourceID(hInstance, 121);
     ClientWidth := BackGroundBitmap.Width;
     ClientHeight := BackGroundBitmap.Height;
     MinImage.Left := 367;
     MinImage.Top := 1;

     CloseImage.Left := 383;
     CloseImage.Top := 1;

     MenuImage.left := 351;
     MenuImage.Top := 1;

     StartBtnImage.Left := 298;
     StartBtnImage.Top := 172;
//     StartBtnImage.Picture.LoadFromFile('start.bmp');
     StartBtnImage.Picture.Bitmap.LoadFromResourceID(hInstance, 127);
     StartBtnImage.Width := StartBtnImage.Picture.Bitmap.Width;
     StartBtnImage.Height := StartBtnImage.Picture.Bitmap.Height;
     Hour := 0;
     Minute := 0;
     Second := 0;
     BombNumber := TOTALBOMBNUMBER;
     InitBomb;
     Image.Left := 24;
     Image.Top := 53;
     Image.Width := 224;
     Image.Height := 224;

     //   Load Bomb Bitmap
     for loop := bsNormal to bsShow do
     begin
          BombStatusBitmap[loop] := TBitmap.Create;
//          BombStatusBitmap[loop].LoadFromFile(BombStatusBitmapName[loop]);
          BombStatusBitmap[loop].LoadFromResourceID(hInstance, BombStatusBitmapName[loop]);
     end;
     with MyNotifyStruct do
     begin
          cbSize := sizeof(MyNotifyStruct);
          Wnd := MainForm.handle;
          uID := 1;
          uFlags :=  NIF_ICON or NIF_TIP or NIF_MESSAGE;
          hIcon := Application.Icon.Handle;
          szTip := 'Sao Lei!';
          uCallBackMessage := WM_TRAYICON;
     end;
     Shell_NotifyIcon(NIM_ADD, @MyNotifyStruct);

end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
{
     if Button = mbLeft then
     begin
          BeginDrag := TRUE;
          bx := X;
          by := Y;
     end;
}
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
{
     if BeginDrag then
     begin
          Left := Left + X - bx;
          Top  := Top  + Y - by;
     end;
}
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
{
     if Button = mbLeft then
     begin
          BeginDrag := False;
     end;
}
end;

procedure TMainForm.DrawTimeAndBombNumber;
var
   s1, s2, s3, s : string;
   x, y : integer;
begin
     s1 := IntToStr(Second);
     if Second < 10 then
     begin
          S1[2] := s1[1];
          S1[1] := '0';
     end;
     s2 := IntToStr(Minute);
     if Minute < 10 then
     begin
          S2[2] := s2[1];
          S2[1] := '0';
     end;

     s3 := IntToStr(Hour);
     if Hour < 10 then
     begin
          S3[2] := s3[1];
          S3[1] := '0';
     end;
     if BombNumber < 0 then BombNumber := 0;
     s := IntToStr(BombNumber);
     if BombNumber < 10 then
     begin
          s[2] := s[1];
          s[1] := '0';
     end;
     x := 283;
     y := 75;
     with ImageLedLNum do
     begin
          Draw(Canvas, x, y, 10);
          Draw(Canvas, x+10, y, StrToInt(s2[1]));
          Draw(Canvas, x+10+18, y, StrToInt(s2[2]));

          Draw(Canvas, x+10+18+18, y, 11);
          Draw(Canvas, x+10+18+18+10, y, StrToInt(s1[1]));
          Draw(Canvas, x+10+18+18+18+10, y, StrToInt(s1[2]));
     end;
     x := 303;
     y := 132;
     with ImageLedLNum do
     begin
          Draw(Canvas, x+10, y, StrToInt(s[1]));
          Draw(Canvas, x+10+18, y, StrToInt(s[2]));
     end;

end;

procedure TMainForm.CloseImageClick(Sender: TObject);
begin
     Close;
end;

procedure TMainForm.CloseImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
     begin
          CloseImage.Picture.Bitmap.LoadFromResourceID(hInstance, 116);
          CloseImage.Width := CloseImage.Picture.Bitmap.Width;
          CloseImage.Height := CloseImage.Picture.Bitmap.Height;
     end;
end;

procedure TMainForm.CloseImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then CloseImage.Picture := nil;
end;

procedure TMainForm.MinImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then MinImage.Picture := nil;
end;

procedure TMainForm.MinImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
     begin
          MinImage.Picture.Bitmap.LoadFromResourceID(hInstance, 117);
          MinImage.Width := MinImage.Picture.Bitmap.Width;
          MinImage.Height := MinImage.Picture.Bitmap.Height;
     end;

end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
     Second := Second + 1;
     if Second >= 60 then
     begin
          Minute := Minute + 1;
          Second := 0;
     end;

     if Minute >= 60 then
     begin
          Hour := Hour + 1;
          Minute := 0;
     end;
     DrawTimeAndBombNumber;
end;

procedure TMainForm.MinImageClick(Sender: TObject);
begin
     if bGameRunning = TRUE then Timer.Enabled := FALSE;
     MainForm.Hide;
{
     with MyNotifyStruct do
     begin
          cbSize := sizeof(MyNotifyStruct);
          Wnd := MainForm.handle;
          uID := 1;
          uFlags :=  NIF_ICON or NIF_TIP or NIF_MESSAGE;
          hIcon := Application.Icon.Handle;
          szTip := 'Hello!';
          uCallBackMessage := WM_TRAYICON;
     end;
     Shell_NotifyIcon(NIM_ADD, @MyNotifyStruct);
}
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer;
begin
     BackGroundBitmap.Free;

     //Save High Scrore
     for i := 0 to 9 do
     begin
          INIFile.WriteString(IntToStr(i), 'Name', HighScore[i].Name);
          INIFile.WriteString(IntToStr(i), 'Date', HighScore[i].Date);
          INIFile.WriteString(IntToStr(i), 'Time', HighScore[i].Time);
     end;
     INIFile.Free;
     with MyNotifyStruct do
     begin
          cbSize := sizeof(MyNotifyStruct);
          Wnd := MainForm.handle;
          uID := 1;
          uFlags :=  NIF_ICON or NIF_TIP or NIF_MESSAGE;
          hIcon := Application.Icon.Handle;
          szTip := 'Hello!';
          uCallBackMessage := WM_TRAYICON;
     end;
     Shell_NotifyIcon(NIM_DELETE, @MyNotifyStruct);
end;

procedure TMainForm.IconCallBackMessage( var Msg : TMessage );
begin
     case Msg.lParam of
          WM_LBUTTONDBLCLK :
                           begin
                                SetForegroundWindow( Application.Handle );
                                Application.ProcessMessages;
                                if bGameRunning = TRUE then Timer.Enabled := TRUE;
                           end;
          WM_RBUTTONDOWN    : DoTrayIconRightClick;
     end;
end;

procedure TMainForm.DoTrayIconRightClick;
var
   MouseCo: Tpoint;
begin
     if MainForm.Visible = TRUE then
        pmShow.Caption := 'H&ide'
     else
        pmShow.Caption := '&Show';


   GetCursorPos(MouseCo);
   SetForegroundWindow( Application.Handle );
   Application.ProcessMessages;
   PopupMenu.Popup( Mouseco.X, Mouseco.Y );
end;

procedure TMainForm.pmCloseClick(Sender: TObject);
begin
     Close;
end;

procedure TMainForm.pmShowClick(Sender: TObject);
begin
     if pmShow.Caption = '&Show' then
     begin
          MainForm.Show;
          if bGameRunning then Timer.Enabled := TRUE;
     end
     else
     begin
          MainForm.Hide;
          if bGameRunning then Timer.Enabled := FALSE;
     end;
end;

procedure TMainForm.WMNCHitTest(var Msg : TWMNCHitTest);
begin
     inherited;
     with Msg do
          with ScreenToClient(Point(XPos,YPos)) do
               if not PtInRect(MinImage.BoundsRect, Point(X,Y))
               and not PtInRect(CloseImage.BoundsRect, Point(X,Y))
               and not PtInRect(MenuImage.BoundsRect, Point(X,Y))
               and not PtInRect(Image.BoundsRect, Point(X,Y))
               and not PtInRect(StartBtnImage.BoundsRect, Point(X,Y)) then
                  Result := htCaption;
end;

procedure TMainForm.InitBomb;
var
   i : integer;
   t : integer;
begin
     for i := 0 to 255 do BombArray[i] := 0;
     for i := 0 to 255 do BombStatusArray[i] := bsNormal;
     i := 0;

     randomize;
     while i < TOTALBOMBNUMBER do
     begin
          t := random(256);
          if BombArray[t] = 0 then
          begin
               BombArray[t] := 1;
               i := i+1;
          end;
     end;

end;

procedure TMainForm.ShowBomb;
var
   x, y : integer;
   i : integer;
begin
     DrawTimeAndBombNumber;
     for i := 0 to 255 do
     begin
          x := i mod 16;
          y := i div 16;
          Canvas.Draw(x*14+24, y*14+53, BombStatusBitmap[BombStatusArray[i]]);
     end;
end;

procedure TMainForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   t : integer;
begin
     if bGameOver then exit;
     if Button = mbLeft then
     begin
          bLeftBtnDown := TRUE;
          ClickNumber := (y div 14)*16+(x div 14);
     end
     else
     if (Button = mbRight) and (bLeftBtnDown = FALSE) then
     begin
          t := (y div 14)*16+(x div 14);
          if BombStatusArray[t] = bsNormal then
          begin
               BombStatusArray[t]:= bsMaskAsBomb;
               BombNumber := BombNumber - 1;
               ShowBomb;
          end
          else
          if BombStatusArray[t] = bsMaskAsBomb then
          begin
               BombStatusArray[t]:= bsNormal;
               BombNumber := BombNumber + 1;
               ShowBomb;
          end;
     end;
     if (Button = mbRight) then bRightBtnDown := TRUE;
end;

procedure TMainForm.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   t : integer;
begin
     if bGameOver then exit;

     if Button = mbLeft then
     begin
          if (bLeftBtnDown = TRUE) and (bRightBtnDown = TRUE) then
          begin
               t := (y div 14)*16+(x div 14);
               CheckIt(t);
          end;
          bLeftBtnDown := FALSE;
          t := (y div 14)*16+(x div 14);
          if t = ClickNumber then
          begin
               Timer.Enabled := TRUE;
               bGameRunning := TRUE;
               DoTurnOver;
               ShowBomb;
          end;
     end
     else
     if Button = mbRight then
     begin
          if (bLeftBtnDown = TRUE) and (bRightBtnDown = TRUE) then
          begin
               t := (y div 14)*16+(x div 14);
               CheckIt(t);
          end;
          bRightBtnDown := FALSE;
          Timer.Enabled := TRUE;
          bGameRunning := TRUE;
     end;
     ShowBomb;

     if YouWin  then
     begin
          PlaySound('SUCCESS', hInstance, SND_RESOURCE or SND_ASYNC);
          bGameOver := TRUE;
          bGameRunning := FALSE;
          Timer.Enabled := FALSE;
          if MakeNewRecord then
             UpdateHighScore
          else
              ShowNormal;
     end;

end;

procedure TMainForm.DoTurnOver;
begin
     if (BombStatusArray[ClickNumber] <> bsMaskAsBomb) and (BombArray[ClickNumber] = 1) then
     begin
          GameOver;
     end
     else
     begin
          if BombStatusArray[ClickNumber] = bsNormal then  TurnItOver(ClickNumber);
          ShowBomb;
     end;
end;
procedure TMainForm.CheckAll;
var
   i, j, k : integer;
   x, y : integer;
begin
     for i := 0 to 255 do
     begin
          x := i mod 16;
          y := i div 16;
          if ((BombStatusArray[i] = bsNumber0) and (BombArray[i] <> -1)) then
          begin
               BombArray[i] := -1;
               for j := -1 to 1 do
               begin
                    for k := -1 to 1 do
                    begin
                         if (x+k>=0) and (x+k<=15) and (y+j>=0) and (y+j<=15) then
                            TurnItOver(i+j*16+k);
                    end;
               end;
          end;
     end;
end;

procedure TMainForm.TurnItOver(n : integer);
var
   i, j : integer;
   Num : integer;
   x, y : integer;
begin
     if BombStatusArray[n] = bsMaskAsBomb then exit;
     Num := 0;

     x := n mod 16;
     y := n div 16;

     for j := -1 to 1 do
     begin
          for i := -1 to 1 do
          begin
               if (x+i>=0) and (x+i<=15) and (y+j>=0) and (y+j<=15) and ((i<>0) or (j<>0)) then
                  if BombArray[n+j*16+i] = 1 then Num := Num+1;
          end;
     end;
     BombStatusArray[n] := BombStatus(2+Num);
     CheckAll;
end;

procedure TMainForm.StartBtnImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
     begin
//          StartBtnImage.Picture.LoadFromFile('startdown.bmp');
          StartBtnImage.Picture.Bitmap.LoadFromResourceID(hInstance,126);
     end;
end;

procedure TMainForm.StartBtnImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
     StartBtnImage.Picture.Bitmap.LoadFromResourceID(hInstance,127);
     //StartBtnImage.Picture.LoadFromFile('start.bmp');
end;

procedure TMainForm.GameOver;
var
   i : integer;
begin
     for i := 0 to 255 do
     begin
          if ( i = ClickNumber) then BombStatusArray[i] := bsExploded
          else
          if (BombArray[i] = 0) and (BombStatusArray[i]=bsMaskAsBomb) then BombStatusArray[i] := bsWrong
          else
          if (BombArray[i] = 0) and (BombStatusArray[i]=bsNormal) then TurnItOver(i)
          else
          if (BombArray[i] = 1) and (BombStatusArray[i]=bsNormal) then BombStatusArray[i] := bsShow;
     end;
     bGameOver := TRUE;
     bGameRunning := FALSE;
     Timer.Enabled := FALSE;
     ShowBomb;
     PlaySound('FAILURE', hInstance, SND_RESOURCE or SND_ASYNC);
end;

procedure TMainForm.StartBtnImageClick(Sender: TObject);
begin
     Hour := 0;
     Minute := 0;
     Second := 0;
     BombNumber := TOTALBOMBNUMBER;
     Timer.Enabled := FALSE;
     bGameOver := FALSE;
     bGameRunning := FALSE;
     InitBomb;
     ShowBomb;
end;

function TMainForm.YouWin:Boolean;
var
   i : integer;
begin
     result := TRUE;
     for i := 0 to 255 do
     begin
          if (BombStatusArray[i] = bsNormal)
             or (BombStatusArray[i] = bsWrong)
             or (BombStatusArray[i] = bsExploded)
             or (BombStatusArray[i] = bsShow)
             then
          begin
               result := FALSE;
               exit;
          end;
     end;
end;

procedure TMainForm.CheckIt(n : integer);
label L1, L2;
var
   i, j, Num : integer;
   x, y : integer;
begin

     if (BombStatusArray[n]<bsNumber1) or (BombStatusArray[n]>bsNumber8)then exit;
     Num := 0;

     x := n mod 16;
     y := n div 16;

     for j := -1 to 1 do
     begin
          for i := -1 to 1 do
          begin
               if (x+i>=0) and (x+i<=15) and (y+j>=0) and (y+j<=15) and ((i<>0) or (j<>0))then
                  if BombStatusArray[n+j*16+i] = bsMaskAsBomb then Num := Num+1;
          end;
     end;

     if BombStatusArray[n] = BombStatus(2+Num) then
     begin
          for j := -1 to 1 do
          begin
               for i := -1 to 1 do
               begin
                    if (x+i>=0) and (x+i<=15) and (y+j>=0) and (y+j<=15) and ((i<>0) or (j<>0)) then
                    begin
                         if (BombArray[n+j*16+i] = 1) and (BombStatusArray[n+j*16+i] <> bsMaskAsBomb) then
                         begin
                              ClickNumber := n+j*16+i;
                              goto L1;
                         end;
                         if BombStatusArray[n+j*16+i] = bsNormal then TurnItOver(n+j*16+i);
                    end;
               end;
          end;
     end;
     goto L2;
L1:

   GameOver;
L2:
end;

function TMainForm.MakeNewRecord:Boolean;
var
   i : integer;
   oldvalue, newvalue : integer;
begin
     MakeNewRecord := FALSE;
     newvalue := Minute*60+Second;
     for i := 0 to 9 do
     begin
          if HighScore[i].Time = '--:--' then
          begin
               MakeNewRecord := TRUE;
               NewRecordPos := i;
               exit;
          end;
          oldvalue := 60*(StrToInt(HighScore[i].Time[1])*10+StrToInt(HighScore[i].Time[2]));
          oldvalue := oldvalue+StrToInt(HighScore[i].Time[4])*10+StrToInt(HighScore[i].Time[5]);
          if oldvalue > newvalue then
          begin
               MakeNewRecord := TRUE;
               NewRecordPos := i;
               exit;
          end;
     end;
end;

procedure TMainForm.UpdateHighScore;
var
   i : integer;
begin
     if AskName.ShowModal = mrOK then
     begin
     for  i := 9 downto NewRecordPos+1 do
     begin
          HighScore[i].Name := HighScore[i-1].Name;
          HighScore[i].Date := HighScore[i-1].Date;
          HighScore[i].Time := HighScore[i-1].Time;
     end;
     HighScore[NewRecordPos].Name := AskName.Edit1.Text;
     HighScore[NewRecordPos].Date := DateToStr(Date);
     HighScore[NewRecordPos].Time := IntToStr(minute div 10)+ IntToStr(minute mod 10)
                                     +':'
                                     +IntToStr(second div 10)+ IntToStr(second mod 10);
     ShowHighScore;
     end;
end;

procedure TMainForm.ShowHighScore;
var
   ScoreForm : THighScoreForm;
   ScoreLabel : array [0..9, 0..2] of TLabel;
   i, j : integer;
begin
       ScoreForm := THighScoreForm.Create(self);

       for i := 0 to 9 do
       begin
            for j := 0 to 2 do
            begin
                   ScoreLabel[i, j] := TLabel.Create(self);
                   ScoreLabel[i, j].Left := 24+j*80;
                   ScoreLabel[i, j].Top := 60+i*20;
                   ScoreLabel[i, j].Parent := ScoreForm;
                   ScoreLabel[i, j].Transparent := TRUE;
                   ScoreLabel[i, j].Font.Size := 8;

            end;
            ScoreLabel[i, 0].Caption := HighScore[i].Name;
            ScoreLabel[i, 1].Caption := HighScore[i].Date;
            ScoreLabel[i, 2].Caption := HighScore[i].Time;
       end;
       try
          ScoreForm.ShowModal;
       finally
              ScoreForm.Destroy;
       end;
       for i := 0 to 9 do
            for j := 0 to 2 do
                   ScoreLabel[i, j].Free;

end;

procedure TMainForm.ShowNormal;
begin
     ShowHighScore;
end;

procedure TMainForm.pmShowHighScoreClick(Sender: TObject);
begin
     if bGameRunning = TRUE then Timer.Enabled := FALSE;
     MainForm.Show;
     ShowNormal;
     if bGameRunning = TRUE then Timer.Enabled := TRUE;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = VK_ESCAPE then MinImageClick(self);
end;

procedure TMainForm.pmAboutClick(Sender: TObject);
begin
    if bGameRunning = TRUE then Timer.Enabled := FALSE;
    MainForm.Show;
    AboutForm.ShowModal;
    if bGameRunning = TRUE then Timer.Enabled := TRUE;
end;

procedure TMainForm.MenuImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then
     begin
          MenuImage.Picture.Bitmap.LoadFromResourceID(hInstance, 129);
          MenuImage.Width := MenuImage.Picture.Bitmap.Width;
          MenuImage.Height := MenuImage.Picture.Bitmap.Height;
     end;
end;

procedure TMainForm.MenuImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbLeft then MenuImage.Picture := nil;
end;

procedure TMainForm.MenuImageClick(Sender: TObject);
begin
     MenuImage.Picture := nil;
     if bGameRunning = TRUE then Timer.Enabled := FALSE;
     AboutForm.ShowModal;
     if bGameRunning = TRUE then Timer.Enabled := TRUE;
end;

end.
